#ifndef _XRT_VERSION_H_
#define _XRT_VERSION_H_

static const char xrt_build_version[] = "2.3.0";

static const char xrt_build_version_branch[] = "2019.2";

static const char xrt_build_version_hash[] = "7e3540d2707443d8c824669ef4272b33ce2f9ba4";

static const char xrt_build_version_hash_date[] = "Fri, 18 Oct 2019 23:59:40 -0700";

static const char xrt_build_version_date_rfc[] = "Tue, 22 Oct 2019 07:31:35 +0000";

static const char xrt_build_version_date[] = "2019-10-22 07:31:35";

static const char xrt_modified_files[] = "";

#define XRT_DRIVER_VERSION "2.3.0,7e3540d2707443d8c824669ef4272b33ce2f9ba4"

# ifdef __cplusplus
#include <iostream>
#include <string>

namespace xrt { 

class version {
 public:
  static void print(std::ostream & output)
  {
     output << "       XRT Build Version: " << xrt_build_version << std::endl;
     output << "    Build Version Branch: " << xrt_build_version_branch << std::endl;
     output << "      Build Version Hash: " << xrt_build_version_hash << std::endl;
     output << " Build Version Hash Date: " << xrt_build_version_hash_date << std::endl;
     output << "      Build Version Date: " << xrt_build_version_date_rfc << std::endl;
  
     std::string modifiedFiles(xrt_modified_files);
     if ( !modifiedFiles.empty() ) {
        const std::string& delimiters = ",";      // Our delimiter
        std::string::size_type lastPos = 0;
        int runningIndex = 1;
        while(lastPos < modifiedFiles.length() + 1) {
          if (runningIndex == 1) {
             output << "  Current Modified Files: ";
          } else {
             output << "                          ";
          }
          output << runningIndex++ << ") ";
  
          std::string::size_type pos = modifiedFiles.find_first_of(delimiters, lastPos);
  
          if (pos == std::string::npos) {
            pos = modifiedFiles.length();
          }
  
          output << modifiedFiles.substr(lastPos, pos-lastPos) << std::endl;
  
          lastPos = pos + 1;
        }
     }
  }
};
}
#endif

#endif 

